//+------------------------------------------------------------------+
//|                                                          CCI.mq5 |
//|                        Copyright 2009, MetaQuotes Software Corp. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright   "2009, MetaQuotes Software Corp."
#property link        "http://www.mql5.com"
#property description "TriBol"
#include <MovingAverages.mqh>
//---
#property indicator_chart_window
#property indicator_buffers 15
#property indicator_plots   3
#property indicator_type1   DRAW_LINE
#property indicator_color1  DarkViolet
#property indicator_type2   DRAW_LINE
#property indicator_color2  DarkViolet
#property indicator_type3   DRAW_LINE
#property indicator_color3  DarkViolet

#property indicator_label1  "Bands middle1"
#property indicator_label2  "Bands upper1"
#property indicator_label3  "Bands lower1"

//--- input parametrs
input int     InpBandsPeriod1=160;       // Period1
input int     InpBandsPeriod2=300;      // Period2
input int     InpBandsPeriod3=370;      // Period3
input int     InpBandsShift1=0;         // Shift1
input int     InpBandsShift2=0;         // Shift2
input int     InpBandsShift3=0;         // Shift3
input double  InpBandsDeviations1=1.5;  // Deviation1
input double  InpBandsDeviations2=1.5;  // Deviation2
input double  InpBandsDeviations3=1.5;  // Deviation3

//--- global variables
int           ExtBandsPeriod1,ExtBandsShift1;
int           ExtBandsPeriod2,ExtBandsShift2;
int           ExtBandsPeriod3,ExtBandsShift3;
int           ExtBandsPeriod4,ExtBandsShift4;

double        ExtBandsDeviations1;
double        ExtBandsDeviations2;
double        ExtBandsDeviations3;

int           ExtPlotBegin1=0;
int           ExtPlotBegin2=0;
int           ExtPlotBegin3=0;
int           ExtPlotBegin4=0;
//---- indicator buffer
double        ExtMLBuffer1[];
double        ExtMLBuffer2[];
double        ExtMLBuffer3[];
double        ExtMLBuffer4[];

double        ExtTLBuffer1[];
double        ExtTLBuffer2[];
double        ExtTLBuffer3[];
double        ExtTLBuffer4[];

double        ExtBLBuffer1[];
double        ExtBLBuffer2[];
double        ExtBLBuffer3[];
double        ExtBLBuffer4[];

double        ExtStdDevBuffer1[];
double        ExtStdDevBuffer2[];
double        ExtStdDevBuffer3[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
void OnInit()
  {
//--- check for input values
   if(InpBandsPeriod1<2)
     {
      ExtBandsPeriod1=20;
      printf("Incorrect value for input variable InpBandsPeriod=%d. Indicator will use value=%d for calculations.",InpBandsPeriod1,ExtBandsPeriod1);
     }
   else ExtBandsPeriod1=InpBandsPeriod1;
   
//--- check for input values   
      if(InpBandsPeriod2<2)
     {
      ExtBandsPeriod2=20;
      printf("Incorrect value for input variable InpBandsPeriod=%d. Indicator will use value=%d for calculations.",InpBandsPeriod2,ExtBandsPeriod2);
     }
   else ExtBandsPeriod2=InpBandsPeriod2;
   
//--- check for input values   
      if(InpBandsPeriod3<2)
     {
      ExtBandsPeriod3=20;
      printf("Incorrect value for input variable InpBandsPeriod=%d. Indicator will use value=%d for calculations.",InpBandsPeriod3,ExtBandsPeriod3);
     }
   else ExtBandsPeriod3=InpBandsPeriod3;
      
   if(InpBandsShift1<0)
     {
      ExtBandsShift1=0;
      printf("Incorrect value for input variable InpBandsShift=%d. Indicator will use value=%d for calculations.",InpBandsShift1,ExtBandsShift1);
     }
   else
      ExtBandsShift1=InpBandsShift1;
      
    if(InpBandsShift2<0)
     {
      ExtBandsShift2=0;
      printf("Incorrect value for input variable InpBandsShift=%d. Indicator will use value=%d for calculations.",InpBandsShift2,ExtBandsShift2);
     }
   else
      ExtBandsShift2=InpBandsShift2;

    if(InpBandsShift3<0)
     {
      ExtBandsShift3=0;
      printf("Incorrect value for input variable InpBandsShift=%d. Indicator will use value=%d for calculations.",InpBandsShift3,ExtBandsShift3);
     }
   else
      ExtBandsShift3=InpBandsShift3;
                 
   if(InpBandsDeviations1==0.0)
     {
      ExtBandsDeviations1=2.0;
      printf("Incorrect value for input variable InpBandsDeviations=%f. Indicator will use value=%f for calculations.",InpBandsDeviations1,ExtBandsDeviations1);
     }
   else ExtBandsDeviations1=InpBandsDeviations1;
   
   if(InpBandsDeviations2==0.0)
     {
      ExtBandsDeviations2=2.0;
      printf("Incorrect value for input variable InpBandsDeviations=%f. Indicator will use value=%f for calculations.",InpBandsDeviations2,ExtBandsDeviations2);
     }
   else ExtBandsDeviations2=InpBandsDeviations2;
   
   if(InpBandsDeviations3==0.0)
     {
      ExtBandsDeviations3=2.0;
      printf("Incorrect value for input variable InpBandsDeviations=%f. Indicator will use value=%f for calculations.",InpBandsDeviations3,ExtBandsDeviations3);
     }
   else ExtBandsDeviations3=InpBandsDeviations3;
   
//--- define buffers
   SetIndexBuffer(9,ExtMLBuffer1);
   SetIndexBuffer(10,ExtTLBuffer1);
   SetIndexBuffer(11,ExtBLBuffer1);
   SetIndexBuffer(12,ExtStdDevBuffer1,INDICATOR_CALCULATIONS);
   
   SetIndexBuffer(3,ExtMLBuffer2);
   SetIndexBuffer(4,ExtTLBuffer2);
   SetIndexBuffer(5,ExtBLBuffer2);
   SetIndexBuffer(13,ExtStdDevBuffer2,INDICATOR_CALCULATIONS);
   
   SetIndexBuffer(6,ExtMLBuffer3);
   SetIndexBuffer(7,ExtTLBuffer3);
   SetIndexBuffer(8,ExtBLBuffer3);
   SetIndexBuffer(14,ExtStdDevBuffer3,INDICATOR_CALCULATIONS);
   
   SetIndexBuffer(0,ExtMLBuffer4);
   SetIndexBuffer(1,ExtTLBuffer4);
   SetIndexBuffer(2,ExtBLBuffer4);
   
//--- set index labels
   PlotIndexSetString(9,PLOT_LABEL,"Bands1("+string(ExtBandsPeriod1)+") Middle1");
   PlotIndexSetString(10,PLOT_LABEL,"Bands1("+string(ExtBandsPeriod1)+") Upper1");
   PlotIndexSetString(11,PLOT_LABEL,"Bands1("+string(ExtBandsPeriod1)+") Lower1");
   
   PlotIndexSetString(3,PLOT_LABEL,"Bands2("+string(ExtBandsPeriod2)+") Middle2");
   PlotIndexSetString(4,PLOT_LABEL,"Bands2("+string(ExtBandsPeriod2)+") Upper2");
   PlotIndexSetString(5,PLOT_LABEL,"Bands2("+string(ExtBandsPeriod2)+") Lower2");
   
   PlotIndexSetString(6,PLOT_LABEL,"Bands3("+string(ExtBandsPeriod3)+") Middle3");
   PlotIndexSetString(7,PLOT_LABEL,"Bands3("+string(ExtBandsPeriod3)+") Upper3");
   PlotIndexSetString(8,PLOT_LABEL,"Bands3("+string(ExtBandsPeriod3)+") Lower3");
   
   PlotIndexSetString(0,PLOT_LABEL,"Bands3("+string(ExtBandsPeriod4)+") Middle4");
   PlotIndexSetString(1,PLOT_LABEL,"Bands3("+string(ExtBandsPeriod4)+") Upper4");
   PlotIndexSetString(2,PLOT_LABEL,"Bands3("+string(ExtBandsPeriod4)+") Lower4");
      
//--- indicator name
   IndicatorSetString(INDICATOR_SHORTNAME,"TriBol");
   
//--- indexes draw begin settings
   ExtPlotBegin1=ExtBandsPeriod1-1;
   ExtPlotBegin2=ExtBandsPeriod2-1;
   ExtPlotBegin3=ExtBandsPeriod3-1;
   ExtPlotBegin4=ExtBandsPeriod4-1;
         
   PlotIndexSetInteger(9,PLOT_DRAW_BEGIN,ExtBandsPeriod1);
   PlotIndexSetInteger(10,PLOT_DRAW_BEGIN,ExtBandsPeriod1);
   PlotIndexSetInteger(11,PLOT_DRAW_BEGIN,ExtBandsPeriod1);
   
   PlotIndexSetInteger(3,PLOT_DRAW_BEGIN,ExtBandsPeriod2);
   PlotIndexSetInteger(4,PLOT_DRAW_BEGIN,ExtBandsPeriod2);
   PlotIndexSetInteger(5,PLOT_DRAW_BEGIN,ExtBandsPeriod2);
      
   PlotIndexSetInteger(6,PLOT_DRAW_BEGIN,ExtBandsPeriod3);
   PlotIndexSetInteger(7,PLOT_DRAW_BEGIN,ExtBandsPeriod3);
   PlotIndexSetInteger(8,PLOT_DRAW_BEGIN,ExtBandsPeriod3);
   
   PlotIndexSetInteger(0,PLOT_DRAW_BEGIN,ExtBandsPeriod4);
   PlotIndexSetInteger(1,PLOT_DRAW_BEGIN,ExtBandsPeriod4);
   PlotIndexSetInteger(2,PLOT_DRAW_BEGIN,ExtBandsPeriod4);    
     
//--- indexes shift settings
   PlotIndexSetInteger(0,PLOT_SHIFT,ExtBandsShift1);
   PlotIndexSetInteger(1,PLOT_SHIFT,ExtBandsShift1);
   PlotIndexSetInteger(2,PLOT_SHIFT,ExtBandsShift1);
   
   //--- indexes shift settings
   PlotIndexSetInteger(3,PLOT_SHIFT,ExtBandsShift2);
   PlotIndexSetInteger(4,PLOT_SHIFT,ExtBandsShift2);
   PlotIndexSetInteger(5,PLOT_SHIFT,ExtBandsShift2);
   
   //--- indexes shift settings
   PlotIndexSetInteger(6,PLOT_SHIFT,ExtBandsShift3);
   PlotIndexSetInteger(7,PLOT_SHIFT,ExtBandsShift3);
   PlotIndexSetInteger(8,PLOT_SHIFT,ExtBandsShift3);
   
//--- number of digits of indicator value
   IndicatorSetInteger(INDICATOR_DIGITS,_Digits+1);
//---- OnInit done
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const int begin,
                const double &price[])
  {
//--- variables
   int pos;
//--- indexes draw begin settings, when we've recieved previous begin
   if(ExtPlotBegin1!=ExtBandsPeriod1+begin)
     {
      ExtPlotBegin1=ExtBandsPeriod1+begin;
      PlotIndexSetInteger(9,PLOT_DRAW_BEGIN,ExtPlotBegin1);
      PlotIndexSetInteger(10,PLOT_DRAW_BEGIN,ExtPlotBegin1);
      PlotIndexSetInteger(11,PLOT_DRAW_BEGIN,ExtPlotBegin1);
     }
//--- check for bars count
   if(rates_total<ExtPlotBegin1)
      return(0);
//--- starting calculation
   if(prev_calculated>1) pos=prev_calculated-1;
   else pos=0;
//--- main cycle
   for(int i=pos;i<rates_total && !IsStopped();i++)
     {
      //--- middle line
      ExtMLBuffer1[i]=SimpleMA(i,ExtBandsPeriod1,price);
      //--- calculate and write down StdDev
      ExtStdDevBuffer1[i]=StdDev_Func(i,price,ExtMLBuffer1,ExtBandsPeriod1);
      //--- upper line
      ExtTLBuffer1[i]=ExtMLBuffer1[i]+ExtBandsDeviations1*ExtStdDevBuffer1[i];
      //--- lower line
      ExtBLBuffer1[i]=ExtMLBuffer1[i]-ExtBandsDeviations1*ExtStdDevBuffer1[i];
      //---
     }
     
     
   if(ExtPlotBegin2!=ExtBandsPeriod2+begin)
     {
      ExtPlotBegin2=ExtBandsPeriod2+begin;
      PlotIndexSetInteger(3,PLOT_DRAW_BEGIN,ExtPlotBegin2);
      PlotIndexSetInteger(4,PLOT_DRAW_BEGIN,ExtPlotBegin2);
      PlotIndexSetInteger(5,PLOT_DRAW_BEGIN,ExtPlotBegin2);
     }
//--- check for bars count
   if(rates_total<ExtPlotBegin2)
      return(0);
//--- starting calculation
   if(prev_calculated>1) pos=prev_calculated-1;
   else pos=0;
//--- main cycle
   for(int i=pos;i<rates_total && !IsStopped();i++)
     {
      //--- middle line
      ExtMLBuffer2[i]=SimpleMA(i,ExtBandsPeriod2,price);
      //--- calculate and write down StdDev
      ExtStdDevBuffer2[i]=StdDev_Func(i,price,ExtMLBuffer2,ExtBandsPeriod2);
      //--- upper line
      ExtTLBuffer2[i]=ExtMLBuffer2[i]+ExtBandsDeviations2*ExtStdDevBuffer2[i];
      //--- lower line
      ExtBLBuffer2[i]=ExtMLBuffer2[i]-ExtBandsDeviations2*ExtStdDevBuffer2[i];
      //---
     }
     
     
       if(ExtPlotBegin3!=ExtBandsPeriod3+begin)
     {
      ExtPlotBegin3=ExtBandsPeriod3+begin;
      PlotIndexSetInteger(6,PLOT_DRAW_BEGIN,ExtPlotBegin3);
      PlotIndexSetInteger(7,PLOT_DRAW_BEGIN,ExtPlotBegin3);
      PlotIndexSetInteger(8,PLOT_DRAW_BEGIN,ExtPlotBegin3);
     }
//--- check for bars count
   if(rates_total<ExtPlotBegin3)
      return(0);
//--- starting calculation
   if(prev_calculated>1) pos=prev_calculated-1;
   else pos=0;
//--- main cycle
   for(int i=pos;i<rates_total && !IsStopped();i++)
     {
      //--- middle line
      ExtMLBuffer3[i]=SimpleMA(i,ExtBandsPeriod3,price);
      //--- calculate and write down StdDev
      ExtStdDevBuffer3[i]=StdDev_Func(i,price,ExtMLBuffer3,ExtBandsPeriod3);
      //--- upper line
      ExtTLBuffer3[i]=ExtMLBuffer3[i]+ExtBandsDeviations3*ExtStdDevBuffer3[i];
      //--- lower line
      ExtBLBuffer3[i]=ExtMLBuffer3[i]-ExtBandsDeviations3*ExtStdDevBuffer3[i];  
      //---
     }
     
      if(ExtPlotBegin4!=ExtBandsPeriod4+begin)
     {
      ExtPlotBegin4=ExtBandsPeriod4+begin;
      PlotIndexSetInteger(0,PLOT_DRAW_BEGIN,ExtPlotBegin4);
      PlotIndexSetInteger(1,PLOT_DRAW_BEGIN,ExtPlotBegin4);
      PlotIndexSetInteger(2,PLOT_DRAW_BEGIN,ExtPlotBegin4);
     }
//--- check for bars count
   if(rates_total<ExtPlotBegin4)
      return(0);
//--- starting calculation
   if(prev_calculated>1) pos=prev_calculated-1;
   else pos=0;
//--- main cycle
   for(int i=pos;i<rates_total && !IsStopped();i++)
     {
      //--- middle line
      ExtMLBuffer4[i]=(ExtMLBuffer3[i]+ExtMLBuffer2[i]+ExtMLBuffer1[i])*0.3333;
      ExtTLBuffer4[i]=(ExtTLBuffer3[i]+ExtTLBuffer2[i]+ExtTLBuffer1[i])*0.3333;
      ExtBLBuffer4[i]=(ExtBLBuffer3[i]+ExtBLBuffer2[i]+ExtBLBuffer1[i])*0.3333;  
     }
     
//---- OnCalculate done. Return new prev_calculated.
   return(rates_total);
  }
  

    
//+------------------------------------------------------------------+
//| Calculate Standard Deviation                                     |
//+------------------------------------------------------------------+
double StdDev_Func(int position,const double &price[],const double &MAprice[],int period)
  {
//--- variables
   double StdDev_dTmp=0.0;
//--- check for position
   if(position<period) return(StdDev_dTmp);
//--- calcualte StdDev
   for(int i=0;i<period;i++) StdDev_dTmp+=MathPow(price[position-i]-MAprice[position],2);
   StdDev_dTmp=MathSqrt(StdDev_dTmp/period);
//--- return calculated value
   return(StdDev_dTmp);
  }
//+------------------------------------------------------------------+